package net.sourceforge.pain.tools.guitool;

import net.sourceforge.pain.tools.guitool.dialog.*;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

public class ToolBar {

    JToolBar toolbar;

    private JButton connectButton;
    private JButton disconnectButton;

    ToolBar() {
        init();
    }

    private void init() {
        toolbar = new JToolBar();
        connectButton = new JButton("Connect");
        connectButton.setRequestFocusEnabled(false);
        connectButton.setMargin(new Insets(1, 1, 1, 1));
        connectButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                GlobalPerformer.connect();
            }
        });

        disconnectButton = new JButton("Disconnect");
        disconnectButton.setRequestFocusEnabled(false);
        disconnectButton.setMargin(new Insets(1, 1, 1, 1));
        disconnectButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                GlobalPerformer.disconnect();
            }
        });

        toolbar.add(connectButton);
        toolbar.add(disconnectButton);
        updateState();
    }

    public JToolBar getJToolBar() {
        return toolbar;
    }

    public void updateState() {
        boolean connected = GlobalPerformer.isConnected();
        connectButton.setEnabled(!connected);
        disconnectButton.setEnabled(connected);
    }

}
