package net.sourceforge.pain.tools.guitool.menu;

import net.sourceforge.pain.tools.guitool.dialog.*;

import javax.swing.*;
import java.awt.event.*;

public class ServerMenu {
    JMenu serverMenu;

    JMenuItem connectItem;
    JMenuItem disconnectItem;
    JMenuItem exitItem;

    public ServerMenu() {
        serverMenu = new JMenu("Server");
        serverMenu.setMnemonic('S');

        connectItem = new JMenuItem("Connect");
        connectItem.setMnemonic('C');
        serverMenu.add(connectItem);

        disconnectItem = new JMenuItem("Disconnect");
        disconnectItem.setMnemonic('D');
        serverMenu.add(disconnectItem);

        serverMenu.addSeparator();

        exitItem = new JMenuItem("Exit");
        exitItem.setMnemonic('E');
        serverMenu.add(exitItem);
        bindActions();

        setConnected(GlobalPerformer.isConnected());
    }


    private void bindActions() {
        connectItem.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                GlobalPerformer.connect();
            }
        });

        disconnectItem.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                GlobalPerformer.disconnect();
            }
        });

        exitItem.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                GlobalPerformer.exit();
            }
        });
    }

    public void setConnected(boolean b) {
        connectItem.setEnabled(!b);
        disconnectItem.setEnabled(b);
    }

}
