package net.sourceforge.pain.tinylib.data.type;

import net.sourceforge.pain.data.*;
import net.sourceforge.pain.data.role.*;
import net.sourceforge.pain.db.*;

/**
 * This reset must be located in Space
 */

public class SpaceReset extends Role {

    private static final int NFIELDS = 1 + LAST_BASE_FIELD_INDEX;

    private final static Class superroles[] = new Class[]{Located.class, Reset.class};

    public SpaceReset(PainDB db) {
        super(db);
    }

    public SpaceReset() {
    }

    public DbClassSchema provideSchema() {
        byte types[] = new byte[NFIELDS];
        String names[] = new String[NFIELDS];

        fillSuperSchema(types, names);

        return new DbClassSchema(types, names);
    }


    public Class[] getSuperroles() {
        return superroles;
    }


    public Reset asReset() {
        return (Reset) getRole(Reset.class);
    }


    public void setResettedPrototype(PrototypeInfo p) {
        asReset().setResettedPrototype(p);
    }

    public Space getLocation() {
        return asLocated().getLocation();
    }

    public void setLocation(Space space) {
        asLocated().setLocation(space);
    }

    public Located asLocated() {
        return (Located) getRole(Located.class);
    }
}